var express = require("express");
var bodyParser = require("body-parser");
var js2xmlparser = require("js2xmlparser");
var request = require('request');
var app = express();
app.set("view engine", "ejs");
app.use(express.static("public"));
app.use(bodyParser.urlencoded({extended: true}));
app.use(bodyParser.json());

//YOUR AUTHENTICATION DATA
const accountSid = "HERE GOES YOU ACCOUNT SID";
const authToken = "HERE GOES YOU AUTH TOKEN";
const callbackAppSid = "HERE GOES AN APPLICATION SID";

//YOUR CONTACT PHONE NUMBER (any number which will be called first) AND CALLERID (must be rented from Apifonica)
const myNumber = "HERE GOES YOUR REAL PHONE NUMBER";
const callerID = "HERE GOES VIRTUAL NUMBER WHICH WILL APPEAR AS CALLER ID";

//OBJECT FOR XML CONSTRUCTION (we will convert it to XML and feed to Apifonica. You can change it for different call behaviour.)
var cbObj = 
    {
        makeCall: {
            number: ""
        }
    };

//ROUTERS

//THIS ROUTER SIMPLY RENDERS THE PAGE WITH A FORM
app.get("/callback", function(req, res) {
    console.log("Someone is requesting your callback page. Rendering index.html...");
    res.render("index");
});

//THIS ROUTER GETS FORM DATA AND MAKES A REQUEST TO APIFONICA TO INITIATE A PHONE CALL
app.post("/callback", function(req, res) {
    console.log("Client entered following phone number: " + req.body.client_number + " and asked for a callback.");
    //SAVING CLIENT'S NUMBER
    cbObj.makeCall.number = req.body.client_number;
    //MAKING A REQUEST TO APIFONICA
    request.post({
        url: "https://" + accountSid + ":" + authToken + "@api.apifonica.com/v2/accounts/" + accountSid +"/calls",
        headers: {'content-type': 'application/json'},
        json: {
            'from': callerID,
            'to': myNumber,
            'call_app_sid': callbackAppSid,
            'events': "all"
            }
        },
      function(error, response, body) {
      if(!error) {
          console.log("APIFONICA RESPONSE:");
          console.log(response.body);
      } else {
          console.log("ERROR:");
          console.log(error);
      }
    });
    res.redirect("/callback");
});

//THIS ROUTER HANDLES THE CALL FLOW AND GETS UPDATES ON CALL EVENTS
app.all("/callback/getxml", function(req, res){
    if(req.body.status.toString() != 'queued') {
        console.log("APIFONICA EVENT UPDATE:");
        console.log(req.body);
        //PLEASE NOTE THAT IF WE DO NOT WANT TO CHANGE THE CALL FLOW, WE ANSWER WITH AN EMPTY STRING AS FOLLOWS
        res.send("");
    } else {
        //SO IF REQUEST STATUS IS "QUEUED" AND APIFONICA WAITS FOR INSTRUCTIONS, WE CONSTRUCT AN XML FILE FROM THE OBJECT ABOVE
        res.send(js2xmlparser.parse("response", cbObj));
        console.log("APIFONICA REQUEST:");
        console.log(req.body);
        console.log("SERVER RESPONSE:");
        console.log(js2xmlparser.parse("response", cbObj));
    }
});

//SERVER
app.listen(process.env.PORT, process.env.IP, function(){
   console.log("Server is listening!!!"); 
});